Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.sqs
Class AmazonSQSAsyncClient

    java.lang.Object
      com.amazonaws.AmazonWebServiceClient
          com.amazonaws.services.sqs.AmazonSQSClient
              com.amazonaws.services.sqs.AmazonSQSAsyncClient

All Implemented Interfaces:
  AmazonSQS, AmazonSQSAsync

    public class AmazonSQSAsyncClient

extends AmazonSQSClient
implements AmazonSQSAsync

Client for accessing AmazonSQS. All calls made using this client are non-blocking and will immediately return a Java Future. Callers must use the Future object to determine when the service call has actually completed.

Amazon Simple Queue Service (Amazon SQS) offers a reliable, highly scalable, hosted queue for storing messages as they travel between computers. By using Amazon SQS, developers can simply move data between distributed components of their applications that perform different tasks, without losing messages or requiring each component to be always available. Amazon SQS makes it easy to build an automated workflow, working in close conjunction with the Amazon Elastic Compute Cloud (Amazon EC2) and the other AWS infrastructure web services.

Amazon SQS works by exposing Amazon's web-scale messaging infrastructure as a web service. Any computer on the Internet can add or read messages without any installed software or special firewall configurations. Components of applications using Amazon SQS can run independently, and do not need to be on the same network, developed with the same technologies, or running at the same time.

Visit http://aws.amazon.com/sqs/ for more information.

Constructor Summary
`AmazonSQSAsyncClient(AWSCredentials awsCredentials)` Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials.
`AmazonSQSAsyncClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration, ExecutorService executorService)` Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials, executor service, and client configuration options.
`AmazonSQSAsyncClient(AWSCredentials awsCredentials, ExecutorService executorService)` Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials and executor service.

Method Summary
`Future<Void>` | `addPermissionAsync(AddPermissionRequest addPermissionRequest)` The AddPermission action adds a permission to a queue for a specific principal.
`Future<Void>` | `changeMessageVisibilityAsync(ChangeMessageVisibilityRequest changeMessageVisibilityRequest)` The ChangeMessageVisibility action changes the visibility timeout of a specified message in a queue to a new value.
`Future<CreateQueueResult>` | `createQueueAsync(CreateQueueRequest createQueueRequest)` The CreateQueue action creates a new queue, or returns the URL of an existing one.
`Future<Void>` | `deleteMessageAsync(DeleteMessageRequest deleteMessageRequest)` The DeleteMessage action unconditionally removes the specified message from the specified queue.
`Future<Void>` | `deleteQueueAsync(DeleteQueueRequest deleteQueueRequest)` This action unconditionally deletes the queue specified by the queue URL.
`ExecutorService` | `getExecutorService()` Returns the executor service used by this async client to execute requests.
`Future<GetQueueAttributesResult>` | `getQueueAttributesAsync(GetQueueAttributesRequest getQueueAttributesRequest)` Gets one or all attributes of a queue.
`Future<ListQueuesResult>` | `listQueuesAsync(ListQueuesRequest listQueuesRequest)` The ListQueues action returns a list of your queues.
`Future<ReceiveMessageResult>` | `receiveMessageAsync(ReceiveMessageRequest receiveMessageRequest)` Retrieves one or more messages from the specified queue, including the message body and message ID of each message.
`Future<Void>` | `removePermissionAsync(RemovePermissionRequest removePermissionRequest)` The RemovePermission action revokes any permissions in the queue policy that matches the specified Label parameter.
`Future<SendMessageResult>` | `sendMessageAsync(SendMessageRequest sendMessageRequest)` The SendMessage action delivers a message to the specified queue.
`Future<Void>` | `setQueueAttributesAsync(SetQueueAttributesRequest setQueueAttributesRequest)` Sets an attribute of a queue.

Methods inherited from class com.amazonaws.services.sqs.AmazonSQSClient
`addPermission, changeMessageVisibility, createQueue, deleteMessage, deleteQueue, getQueueAttributes, listQueues, listQueues, receiveMessage, removePermission, sendMessage, setQueueAttributes`

Methods inherited from class com.amazonaws.AmazonWebServiceClient
`setEndpoint, shutdown`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.amazonaws.services.sqs.AmazonSQS
`addPermission, changeMessageVisibility, createQueue, deleteMessage, deleteQueue, getQueueAttributes, listQueues, listQueues, receiveMessage, removePermission, sendMessage, setEndpoint, setQueueAttributes, shutdown`

Constructor Detail

### AmazonSQSAsyncClient

    public AmazonSQSAsyncClient(AWSCredentials awsCredentials)

  Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials. Default client settings will be used, and a default cached thread pool will be created for executing the asynchronous tasks.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

### AmazonSQSAsyncClient

    public AmazonSQSAsyncClient(AWSCredentials awsCredentials,
                                ExecutorService executorService)

  Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials and executor service. Default client settings will be used.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `executorService` - The executor service by which all asynchronous requests will be executed.

### AmazonSQSAsyncClient

    public AmazonSQSAsyncClient(AWSCredentials awsCredentials,
                                ClientConfiguration clientConfiguration,
                                ExecutorService executorService)

  Constructs a new asynchronous client to invoke service methods on AmazonSQS using the specified AWS account credentials, executor service, and client configuration options.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `clientConfiguration` - Client configuration options (ex: max retry limit, proxy settings, etc).
    `executorService` - The executor service by which all asynchronous requests will be executed.

Method Detail

### getExecutorService

    public ExecutorService getExecutorService()

  Returns the executor service used by this async client to execute requests.

  Returns:
    The executor service used by this async client to execute requests.

### listQueuesAsync

    public Future<ListQueuesResult> listQueuesAsync(ListQueuesRequest listQueuesRequest)
                                             throws AmazonServiceException,
                                                    AmazonClientException

  The ListQueues action returns a list of your queues.

  Specified by:
    `listQueuesAsync` in interface `AmazonSQSAsync`
  Parameters:
    `listQueuesRequest` - Container for the necessary parameters to execute the ListQueues operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the ListQueues service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### setQueueAttributesAsync

    public Future<Void> setQueueAttributesAsync(SetQueueAttributesRequest setQueueAttributesRequest)
                                         throws AmazonServiceException,
                                                AmazonClientException

  Sets an attribute of a queue. Currently, you can set only the VisibilityTimeout attribute for a queue.

  Specified by:
    `setQueueAttributesAsync` in interface `AmazonSQSAsync`
  Parameters:
    `setQueueAttributesRequest` - Container for the necessary parameters to execute the SetQueueAttributes operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the SetQueueAttributes service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### changeMessageVisibilityAsync

    public Future<Void> changeMessageVisibilityAsync(ChangeMessageVisibilityRequest changeMessageVisibilityRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The ChangeMessageVisibility action changes the visibility timeout of a specified message in a queue to a new value. The maximum allowed timeout value you can set the value to is 12 hours. This means you can't extend the timeout of a message in an existing queue to more than a total visibility timeout of 12 hours. (For more information visibility timeout, see Visibility Timeout in the Amazon SQS Developer Guide.)

  For example, let's say you have a message and its default message visibility timeout is 30 minutes. You could call ChangeMessageVisiblity with a value of two hours and the effective timeout would be two hours and 30 minutes. When that time comes near you could again extend the time out by calling ChangeMessageVisiblity, but this time the maximum allowed timeout would be 9 hours and 30 minutes.

  IMPORTANT: If you attempt to set the VisibilityTimeout to an amount more than the maximum time left, Amazon SQS returns an error. It will not automatically recalculate and increase the timeout to the maximum time remaining.

  IMPORTANT: Unlike with a queue, when you change the visibility timeout for a specific message, that timeout value is applied immediately but is not saved in memory for that message. If you don't delete a message after it is received, the visibility timeout for the message the next time it is received reverts to the original timeout value, not the value you set with the ChangeMessageVisibility action.

  Specified by:
    `changeMessageVisibilityAsync` in interface `AmazonSQSAsync`
  Parameters:
    `changeMessageVisibilityRequest` - Container for the necessary parameters to execute the ChangeMessageVisibility operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the ChangeMessageVisibility service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### createQueueAsync

    public Future<CreateQueueResult> createQueueAsync(CreateQueueRequest createQueueRequest)
                                               throws AmazonServiceException,
                                                      AmazonClientException

  The CreateQueue action creates a new queue, or returns the URL of an existing one. When you request CreateQueue, you provide a name for the queue. To successfully create a new queue, you must provide a name that is unique within the scope of your own queues. If you provide the name of an existing queue, a new queue isn't created and an error isn't returned. Instead, the request succeeds and the queue URL for the existing queue is returned.

  IMPORTANT: If you provide a value for DefaultVisibilityTimeout that is different from the value for the existing queue, you receive an error.

  Specified by:
    `createQueueAsync` in interface `AmazonSQSAsync`
  Parameters:
    `createQueueRequest` - Container for the necessary parameters to execute the CreateQueue operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the CreateQueue service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### removePermissionAsync

    public Future<Void> removePermissionAsync(RemovePermissionRequest removePermissionRequest)
                                       throws AmazonServiceException,
                                              AmazonClientException

  The RemovePermission action revokes any permissions in the queue policy that matches the specified Label parameter. Only the owner of the queue can remove permissions.

  Specified by:
    `removePermissionAsync` in interface `AmazonSQSAsync`
  Parameters:
    `removePermissionRequest` - Container for the necessary parameters to execute the RemovePermission operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the RemovePermission service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### getQueueAttributesAsync

    public Future<GetQueueAttributesResult> getQueueAttributesAsync(GetQueueAttributesRequest getQueueAttributesRequest)
                                                             throws AmazonServiceException,
                                                                    AmazonClientException

  Gets one or all attributes of a queue. Queues currently have two attributes you can get: ApproximateNumberOfMessages and VisibilityTimeout.

  Specified by:
    `getQueueAttributesAsync` in interface `AmazonSQSAsync`
  Parameters:
    `getQueueAttributesRequest` - Container for the necessary parameters to execute the GetQueueAttributes operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the GetQueueAttributes service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### addPermissionAsync

    public Future<Void> addPermissionAsync(AddPermissionRequest addPermissionRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The AddPermission action adds a permission to a queue for a specific principal. This allows for sharing access to the queue.

  When you create a queue, you have full control access rights for the queue. Only you (as owner of the queue) can grant or deny permissions to the queue. For more information about these permissions, see Shared Queues in the Amazon SQS Developer Guide.

  Specified by:
    `addPermissionAsync` in interface `AmazonSQSAsync`
  Parameters:
    `addPermissionRequest` - Container for the necessary parameters to execute the AddPermission operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the AddPermission service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### deleteQueueAsync

    public Future<Void> deleteQueueAsync(DeleteQueueRequest deleteQueueRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  This action unconditionally deletes the queue specified by the queue URL. Use this operation WITH CARE! The queue is deleted even if it is NOT empty.

  Specified by:
    `deleteQueueAsync` in interface `AmazonSQSAsync`
  Parameters:
    `deleteQueueRequest` - Container for the necessary parameters to execute the DeleteQueue operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the DeleteQueue service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### deleteMessageAsync

    public Future<Void> deleteMessageAsync(DeleteMessageRequest deleteMessageRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The DeleteMessage action unconditionally removes the specified message from the specified queue. Even if the message is locked by another reader due to the visibility timeout setting, it is still deleted from the queue.

  Specified by:
    `deleteMessageAsync` in interface `AmazonSQSAsync`
  Parameters:
    `deleteMessageRequest` - Container for the necessary parameters to execute the DeleteMessage operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the DeleteMessage service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### sendMessageAsync

    public Future<SendMessageResult> sendMessageAsync(SendMessageRequest sendMessageRequest)
                                               throws AmazonServiceException,
                                                      AmazonClientException

  The SendMessage action delivers a message to the specified queue.

  Specified by:
    `sendMessageAsync` in interface `AmazonSQSAsync`
  Parameters:
    `sendMessageRequest` - Container for the necessary parameters to execute the SendMessage operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the SendMessage service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### receiveMessageAsync

    public Future<ReceiveMessageResult> receiveMessageAsync(ReceiveMessageRequest receiveMessageRequest)
                                                     throws AmazonServiceException,
                                                            AmazonClientException

  Retrieves one or more messages from the specified queue, including the message body and message ID of each message. Messages returned by this action stay in the queue until you delete them. However, once a message is returned to a ReceiveMessage request, it is not returned on subsequent ReceiveMessage requests for the duration of the VisibilityTimeout. If you do not specify a VisibilityTimeout in the request, the overall visibility timeout for the queue is used for the returned messages.

  Specified by:
    `receiveMessageAsync` in interface `AmazonSQSAsync`
  Parameters:
    `receiveMessageRequest` - Container for the necessary parameters to execute the ReceiveMessage operation on AmazonSQS.
  Returns:
    A Java Future object containing the response from the ReceiveMessage service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.